#ifndef GAME_H
#define GAME_H

    #include <avr/io.h>
    #include <avr/wdt.h>
    #include <avr/power.h>
    #include <avr/interrupt.h>
    #include <stdbool.h>
    #include <string.h>
    #include <stdlib.h>
    #include <util/delay.h>

    #include "Descriptors.h"

    #include <LUFA/Drivers/USB/USB.h>
    #include <LUFA/Drivers/Board/LEDs.h>
    #include <LUFA/Platform/Platform.h>

    #define LED_COUNT 3

    #define LED_WIN_LOSE_DELAY 10
    #define BASE_LIVES 3
    #define BASE_DELAY 100
    #define NEXT_STATE_DELAY 10000
    #define BASE_LEVEL 5

    #define IDLE_STATE 0
    #define WAIT_STATE 1
    #define SHOW_STATE 2
    #define GAME_STATE 3

    static int ledState = IDLE_STATE;
    static int nextLed = 0;
    static int nextLedState = 0;

    void init_simon_game();

    void execute_simon_game();

    void show_game_next();

    void switch_led_on(uint8_t ledNumber);

    void switch_led_off(uint8_t ledNumber);
#endif // GAME_H